/* orfeomeImageIds.h was originally generated by the autoSql program, which also 
 * generated orfeomeImageIds.c and orfeomeImageIds.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef ORFEOMEIMAGEIDS_H
#define ORFEOMEIMAGEIDS_H

#define ORFEOMEIMAGEIDS_NUM_COLS 4

struct orfeomeImageIds
/* file of orfeome IMAGE id ranges */
    {
    struct orfeomeImageIds *next;  /* Next in singly linked list. */
    int imageFirst;	/* first IMAGE id in range */
    int imageLast;	/* last IMAGE id in range */
    char *organism;	/* organism name */
    char *comment;	/* comment */
    };

void orfeomeImageIdsStaticLoad(char **row, struct orfeomeImageIds *ret);
/* Load a row from orfeomeImageIds table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct orfeomeImageIds *orfeomeImageIdsLoad(char **row);
/* Load a orfeomeImageIds from row fetched with select * from orfeomeImageIds
 * from database.  Dispose of this with orfeomeImageIdsFree(). */

struct orfeomeImageIds *orfeomeImageIdsLoadAll(char *fileName);
/* Load all orfeomeImageIds from whitespace-separated file.
 * Dispose of this with orfeomeImageIdsFreeList(). */

struct orfeomeImageIds *orfeomeImageIdsLoadAllByChar(char *fileName, char chopper);
/* Load all orfeomeImageIds from chopper separated file.
 * Dispose of this with orfeomeImageIdsFreeList(). */

#define orfeomeImageIdsLoadAllByTab(a) orfeomeImageIdsLoadAllByChar(a, '\t');
/* Load all orfeomeImageIds from tab separated file.
 * Dispose of this with orfeomeImageIdsFreeList(). */

struct orfeomeImageIds *orfeomeImageIdsCommaIn(char **pS, struct orfeomeImageIds *ret);
/* Create a orfeomeImageIds out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new orfeomeImageIds */

void orfeomeImageIdsFree(struct orfeomeImageIds **pEl);
/* Free a single dynamically allocated orfeomeImageIds such as created
 * with orfeomeImageIdsLoad(). */

void orfeomeImageIdsFreeList(struct orfeomeImageIds **pList);
/* Free a list of dynamically allocated orfeomeImageIds's */

void orfeomeImageIdsOutput(struct orfeomeImageIds *el, FILE *f, char sep, char lastSep);
/* Print out orfeomeImageIds.  Separate fields with sep. Follow last field with lastSep. */

#define orfeomeImageIdsTabOut(el,f) orfeomeImageIdsOutput(el,f,'\t','\n');
/* Print out orfeomeImageIds as a line in a tab-separated file. */

#define orfeomeImageIdsCommaOut(el,f) orfeomeImageIdsOutput(el,f,',',',');
/* Print out orfeomeImageIds as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* ORFEOMEIMAGEIDS_H */

